//package opt.mapas;
import redis.clients.jedis.*;
import redis.clients.util.*;
import redis.clients.jedis.exceptions.*;
import java.util.*;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import java.io.*;
public class Speed_all {
	 public static void main(String[] args) {
		 	Date ahora = new Date(); 
		 	long nowLong = ahora.getTime();
	        Jedis jedis = new Jedis("127.0.0.1");
			jedis.auth("sentilo");
			jedis.dbSize();
			FileWriter file = null;
			PrintWriter pw = null;
			int i = 0;
			try{
				file = new FileWriter("/var/www/mapas/speed.json");
				pw = new PrintWriter(file);
				String json = "";
				String location;
				String tiempo;
				String data;
				String strLatitud;
				float latitud;
				String strLongitud;
				float longitud;
				int blanco;
				Set<String> sdid = jedis.zrange("sid:2:observations", 0, -1);
				Iterator it=sdid.iterator();
				JSONObject obj = new JSONObject();
				JSONArray lisPuntos = new JSONArray();
				while(it.hasNext())
		          {
				  JSONObject puntos = new JSONObject();
				  JSONObject punto = new JSONObject();
				  JSONObject valores = new JSONObject();
				  JSONArray coordenadas = new JSONArray();
				  String iteracion = (String)it.next();
				  String value ="sdid:" + iteracion; 
				  location = jedis.hget(value,"location");
				  tiempo = jedis.hget(value,"ts");
				  data = jedis.hget(value, "data");    
				  if(location != null){
					  blanco = location.indexOf(" ");
					  strLatitud = location.substring(0, blanco);
					  latitud = Float.parseFloat(strLatitud);
					  strLongitud = location.substring(blanco + 1);
					  longitud = Float.parseFloat(strLongitud);
				  }else{
					  longitud = 0; 
					  latitud = 0;
				  }
				  coordenadas.add(longitud);
				  coordenadas.add(latitud);
				  punto.put("type", "Point");
				  valores.put("prop0",data);
				  punto.put("coordinates", coordenadas);
				  puntos.put("properties", valores);
				  puntos.put("type", "Feature");
				  puntos.put("geometry", punto);
				  lisPuntos.add(puntos);
		        }
		        obj.put("type","FeatureCollection");
				obj.put("features", lisPuntos);	
				String objstring = obj.toString(); 
				pw.println(objstring);
		    }catch (IOException e) {e.printStackTrace();}
			finally {
				try{
					if (null != file) file.close();
					} catch (Exception e2) {
						e2.printStackTrace();
					}}
			}
}
