package cat.bcn.noise;
import org.json.JSONArray;
import org.json.JSONObject;
/**
 * Obtiene las observaciones y las empaqueta en formato JSON
 * @author Esteban Roman Castellanos
 * @version 1.0    
*/
public class Json{
	public static String formato(Noise ruido, GeoLocation loc1) {
	  String json = "";
	  String location;
	  location = Double.toString(loc1.getLatitud()) + " " + Double.toString(loc1.getLongitud());
	  try{
		JSONObject observacion = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject valores = new JSONObject();
		valores.put("location", location);
		valores.put("value", ruido.getVolumen());
		array.put(valores);
		observacion.accumulate("observations", array);
		json = observacion.toString();
	  }catch(Exception e){e.printStackTrace();} 
	  return json;
	}
}