package cat.bcn.speed;
import org.json.JSONArray;
import org.json.JSONObject;
/**
 * Obtiene las observaciones y las empaqueta en formato JSON
 * @author Esteban Roman Castellanos
 * @version 1.0
*/
public class Json{
	public static String formato(GeoLocation loc1) {
	  String json = "";
	  String location;
	  //Float velocidadkmh;
	  location = Double.toString(loc1.getLatitud()) + " " + Double.toString(loc1.getLongitud());
	  try{
		JSONObject observacion = new JSONObject();
		JSONArray array = new JSONArray();
		JSONObject valores = new JSONObject();
		valores.put("location", location);
		//Pasamos de metros por segundo a kilómetros por hora
		//velocidadkmh = loc1.getVelocidad();
		//valores.put("value", velocidadkmh);
		valores.put("value",loc1.getVelocidad());
		array.put(valores);
		observacion.accumulate("observations", array);
		json = observacion.toString();
	  }catch(Exception e){e.printStackTrace();} 
	  return json;
	}
}